<?php

/*
 @nom: Event
 @auteur: Idleman (idleman@idleman.fr)
 @description: Classe de gestion des évenements/news liés a chaques flux RSS/ATOM
 */

class Event extends MysqlEntity{

	protected $id,$title,$guid,$content,$description,$pudate,$link,$feed,$category,$creator,$unread,$favorite;
	protected $TABLE_NAME = 'event';
	protected $CLASS_NAME = 'Event';
	protected $object_fields = 
	array(
		'id'=>'key',
		'guid'=>'longstring',
		'title'=>'string',
		'creator'=>'string',
		'content'=>'longstring',
		'description'=>'longstring',
		'link'=>'longstring',
		'unread'=>'integer',
		'feed'=>'integer',
		'unread'=>'integer',
		'favorite'=>'integer',
		'pubdate'=>'integer'
	);

	function __construct($guid=null,$title=null,$description=null,$content=null,$pubdate=null,$link=null,$category=null,$creator=null){
		
		$this->guid = $guid;
		$this->title = $title;
		$this->creator = $creator;
		$this->content = $content;
		$this->description = $description;
		$this->pubdate = $pubdate;
		$this->link = $link;
		$this->category = $category;
		parent::__construct();
	}


	function getEventCountPerFolder(){
		$events = array();
		$results = $this->customQuery('SELECT COUNT('.MYSQL_PREFIX.$this->TABLE_NAME.'.id),'.MYSQL_PREFIX.'folder.id FROM '.MYSQL_PREFIX.$this->TABLE_NAME.' INNER JOIN '.MYSQL_PREFIX.'feed ON ('.MYSQL_PREFIX.'event.feed = '.MYSQL_PREFIX.'feed.id) INNER JOIN '.MYSQL_PREFIX.'folder ON ('.MYSQL_PREFIX.'folder.id = '.MYSQL_PREFIX.'feed.folder) WHERE '.MYSQL_PREFIX.$this->TABLE_NAME.'.unread=1 GROUP BY '.MYSQL_PREFIX.'folder.id');
		
		while($item = mysql_fetch_array($results)){
			$events[$item[1]] = $item[0];
		}
		
		return $events;
	}

	function setId($id){
		$this->id = $id;
	}

	function getCreator(){
		return $this->creator;
	}

	function setCreator($creator){
		$this->creator = $creator;
	}

	function getCategory(){
		return $this->category;
	}

	function setCategory($category){
		$this->category = $category;
	}

	function getDescription(){
		// return utf8_encode($this->description);
		return $this->description;
	}

	function setDescription($description,$encoding = true){
		$this->description =  str_replace('’','\'',$description);
		if($encoding)$this->description = utf8_decode($this->description);
	}

	function getPubdate($format=false){
		if($this->pubdate!=0){
		return ($format!=false?date($format,$this->pubdate):$this->pubdate);
		}else{
			return '';
		}
	}

	function getPubdateWithInstant($instant){
		$alpha = $instant - $this->pubdate;
		if ($alpha < 86400 ){
			$hour = floor($alpha/3600);
			$alpha = ($hour!=0?$alpha-($hour*3600):$alpha);
			$minuts = floor($alpha/60);
			return ' '.($hour!=0?$hour.'h et':'').' '.$minuts.'min ago';
		}else{
			return 'on '.$this->getPubdate('d/m/Y at H:i:s');
		}
	}

	function setPubdate($pubdate){
		$this->pubdate = strtotime($pubdate);
	}

	function getLink(){
		return $this->link;
	}

	function setLink($link){
		$this->link = $link;
	}

	function getId(){
		return $this->id;
	}

	function getTitle(){
		return $this->title;
	}

	function setTitle($title){
		$this->title = $title;
	}

	function getContent(){
		//return utf8_encode($this->content);
		return $this->content;
	}

	function setContent($content,$encoding=true){
		$this->content = str_replace('’','\'',$content);
		if($encoding)$this->content = utf8_decode($this->content);
	}


	function getGuid(){
		return $this->guid;
	}

	function setGuid($guid){
		$this->guid = $guid;
	}

	function getUnread(){
		return $this->unread;
	}

	function setUnread($unread){
		$this->unread = $unread;
	}
	function setFeed($feed){
		$this->feed = $feed;
	}
	function getFeed(){
		return $this->feed;
	}
	function setFavorite($favorite){
		$this->favorite = $favorite;
	}
	function getFavorite(){
		return $this->favorite;
	}

}

?>