<?php

/*
 @nom: action
 @auteur: Idleman (idleman@idleman.fr)
 @description: Page de gestoin des evenements non liés a une vue particulière (appels ajax, requetes sans resultats etc...)
 */

if(!ini_get('safe_mode')) @set_time_limit(0);
require_once("common.php");



//Execution du code en fonction de l'action
switch ($_['action']){

	case 'synchronize':
		if (ob_get_level() == 0) ob_start();
		require_once("SimplePie.class.php");

		
		echo '<link rel="stylesheet" href="templates/marigolds/css/style.css"><ul style="font-family:Verdana;">';
		echo str_pad('',4096)."\n";ob_flush();flush();

		if (isset($_['code']) && $configurationManager->get('synchronisationCode')!=null && $_['code'] == $configurationManager->get('synchronisationCode')){

		$synchronisationType = $configurationManager->get('synchronisationType');
		$maxEvents = $configurationManager->get('feedMaxEvents');

		

			echo '<h3>Synchronisation of '.date('d/m/Y H:i:s').'</h3>';
			echo '<hr/>';
			echo str_pad('',4096)."\n";ob_flush();flush();

		if($synchronisationType=='graduate'){
			$feeds = $feedManager->loadAll(null,'lastupdate','10');
			echo 'Graduaded type...<br/>';
			echo str_pad('',4096)."\n";ob_flush();flush();
		}else{
			$feeds = $feedManager->populate('name');
			echo 'Complete type...<br/>';
			echo str_pad('',4096)."\n";ob_flush();flush();
		}	
			
			echo count($feeds).' Feeds to synchronize...<br/>';
			echo str_pad('',4096)."\n";ob_flush();flush();
		foreach ($feeds as $feed) {
			echo date('H:i:s').' - Flux '.$feed->getName().' ('.$feed->getUrl().') parding feeds...<br/>';
			echo str_pad('',4096)."\n";ob_flush();flush();
			$feed->parse();
			echo str_pad('',4096)."\n";ob_flush();flush();
			echo date('H:i:s').' - Flux '.$feed->getName().' ('.$feed->getUrl().') deletion of old evnets...<br/>';
			echo str_pad('',4096)."\n";ob_flush();flush();
			if($maxEvents!=0) $feed->removeOldEvents($maxEvents);
			echo date('H:i:s').' - Flux '.$feed->getName().' ('.$feed->getUrl().') done <br/>';
			echo str_pad('',4096)."\n";ob_flush();flush();
		}
			echo date('H:i:s').' - Synchronisation done ( '.number_format(microtime(true)-$start,3).' secondes )<br/>';
		echo str_pad('',4096)."\n";ob_flush();flush();

	}else{
		echo 'Wrong or not specified synchronzation code';
	}

		ob_end_flush();

	break;


	case 'readAll':
		if($myUser==false) exit('You have to login for this action.');
		$whereClause = array();
		$whereClause['unread'] = '1';
		if(isset($_['feed']))$whereClause['feed'] = $_['feed'];
		$eventManager->change(array('unread'=>'0'),$whereClause);
		header('location: ./index.php');
	break;

	case 'readFolder':
		if($myUser==false) exit('You have to login for this action.');

		$feeds = $feedManager->loadAllOnlyColumn('id',array('folder'=>$_['folder']));
		
		foreach($feeds as $feed){
			$eventManager->change(array('unread'=>'0'),array('feed'=>$feed->getId()));
		}

		header('location: ./index.php');

	break;

	case 'updateConfiguration':
		if($myUser==false) exit('You have to login for this action.');


			//Ajout des préférences et reglages
			$configurationManager->put('root',(substr($_['root'], strlen($_['root'])-1)=='/'?$_['root']:$_['root'].'/'));
			//$configurationManager->put('view',$_['view']);
			$configurationManager->put('articleView',$_['articleView']);
			$configurationManager->put('articleDisplayContent',$_['articleDisplayContent']);
			$configurationManager->put('articleDisplayAnonymous',$_['articleDisplayAnonymous']);

			$configurationManager->put('articlePerPages',$_['articlePerPages']);
			$configurationManager->put('articleDisplayLink',$_['articleDisplayLink']);
			$configurationManager->put('articleDisplayDate',$_['articleDisplayDate']);
			$configurationManager->put('articleDisplayAuthor',$_['articleDisplayAuthor']);
			$configurationManager->put('plugin_shaarli',(isset($_['plugin_shaarli']) && $_['plugin_shaarli']=='on'?1:0));
			$configurationManager->put('plugin_shaarli_link',$_['plugin_shaarli_link']);
			$configurationManager->put('synchronisationType',$_['synchronisationType']);
			$configurationManager->put('feedMaxEvents',$_['feedMaxEvents']);

	
		
			 $userManager->change(array('login'=>$_['login']),array('id'=>$myUser->getId()));
			 if(trim($_['password'])!='') $userManager->change(array('password'=>User::encrypt($_['password'])),array('id'=>$myUser->getId()));
		


	header('location: ./settings.php');
	break;


	case 'purge':
		if($myUser==false) exit('You have to login for this action.');
		$eventManager->truncate();
		header('location: ./settings.php');
	break;


	case 'exportFeed':
				/*********************/
			/** Export **/
			/*********************/
			if(isset($_POST['exportButton'])){
				$feeds = $feedManager->populate('name');
				$folders = $folderManager->loadAll(array('parent'=>-1),'name');
				$xmlStream = '<?xml version="1.0" encoding="utf-8"?>
	<opml version="2.0">
		<head>
			<title>Leed export</title>
			<ownerName>Leed</ownerName>
			<ownerEmail>idleman@idleman.fr</ownerEmail>
			<dateCreated>'.date('D, d M Y H:i:s').'+0000</dateCreated>
		</head>
		<body>';

				$xmlStream .= Functions::recursiveExportOutline($folders);
				// foreach($folders as $folder){
				// 	$feeds = $folder->getFeeds();
				// 	$xmlStream .='<outline text="'.$folder->getName().'" title="'.$folder->getName().'" icon="">'."\n";
				// 		foreach($feeds as $feed){
				// 			$xmlStream .= '				<outline xmlUrl="'.$feed->getUrl().'" htmlUrl="'.$feed->getWebsite().'" text="'.$feed->getDescription().'" title="'.$feed->getName().'" description="'.$feed->getDescription().'" />'."\n";
				// 		}
				// 	$xmlStream .= '			</outline>';
				// }
				
		$xmlStream .= '</body>
	</opml>';


				header('Content-Description: File Transfer');
			    header('Content-Type: application/octet-stream');
			    header('Content-Disposition: attachment; filename=leed-'.date('d-m-Y').'.opml');
			    header('Content-Transfer-Encoding: binary');
			    header('Expires: 0');
			    header('Cache-Control: must-revalidate');
			    header('Pragma: public');
			    header('Content-Length: ' . strlen($xmlStream));
			    /*
				//A decommenter dans le cas ou on a des pb avec ie
				if(preg_match('/msie|(microsoft internet explorer)/i', $_SERVER['HTTP_USER_AGENT'])){
				  header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				  header('Pragma: public');
				}else{
				  header('Pragma: no-cache');
				}
			    */
			    ob_clean();
			    flush();
			    echo $xmlStream;

			}
	break;
	

	case 'importForm':
		echo '<link rel="stylesheet" href="templates/marigolds/css/style.css"><form action="action.php?action=importFeed" method="POST" enctype="multipart/form-data"><h2>Import feeds in opml format</h2>
					<p>OPML File : <input name="newImport" type="file"/> <button name="importButton">Import</button></p>
					<p>Nb : Import can take a while, let your browser do the job and go grab a coffee :).</p></form>
				
			';
	break;

	case 'synchronizeForm':
	 if(isset($myUser) && $myUser!=false){  
		echo '<link rel="stylesheet" href="templates/marigolds/css/style.css">
				<a class="button" href="action.php?action=synchronize&format=html&code='.$configurationManager->get('synchronisationCode').'">Synchronize now</a>
					<p>Nb : Synchronization can take a while, let your browser do the job and go grab a coffee :).</p>
				
			';
		}else{
			echo 'You have to login to access this page';
		}

	break;

	case 'changeFolderState':
		if($myUser==false) exit('You have to login for this action.');
		$folderManager->change(array('isopen'=>$_['isopen']),array('id'=>$_['id']));
	break;

	case 'importFeed':
				require_once("SimplePie.class.php");
				if (ob_get_level() == 0) ob_start();
				ignore_user_abort(true);
			
				echo '<link rel="stylesheet" href="templates/marigolds/css/style.css"><ul style="font-family:Verdana;">';
				echo str_pad('',4096)."\n";ob_flush();flush();
				

				if($myUser==false) exit('You have to login for this action.');
				if(isset($_POST['importButton'])){
			
				echo '<li>Reading OPML file...</li>';
				echo str_pad('',4096)."\n";ob_flush();flush();
				$xml = simplexml_load_file($_FILES['newImport']['tmp_name']);
				$report = 'Import started : '.date('d/m/Y H:i:s')."\n";
				echo '<li>Parsing OPML file...</li>';
				echo str_pad('',4096)."\n";ob_flush();flush();
				$report .= Functions::recursiveImportXmlOutline($xml->body->outline,1);
				$report .= 'Import ended : '.date('d/m/Y H:i:s')."\n";
				echo '<li>Writing import logs....</li>';
				echo str_pad('',4096)."\n";ob_flush();flush();
				file_put_contents('./logs/Import of '.date('d-m-Y').'.log', $report ,FILE_APPEND);
				echo '<li>Feed import done ( '.number_format(microtime(true)-$start,3).' secondes ).</li>';
				echo str_pad('',4096)."\n";ob_flush();flush();

				echo '</ul>';
				echo str_pad('',4096)."\n";ob_flush();flush();

				ob_end_flush();
				//header('location: ./settings.php');
			}
	break;

	
	case 'addFeed':
			require_once("SimplePie.class.php");
			if($myUser==false) exit('You have to login for this action.');
			if(isset($_['newUrl'])){
				$newFeed = new Feed();
				$newFeed->setUrl($_['newUrl']);
				$newFeed->getInfos();
				$newFeed->setFolder((isset($_['newUrlCategory'])?$_['newUrlCategory']:1));
				$newFeed->setColor(Functions::hexaValue($_['newUrl']));
				$newFeed->save();
				$newFeed->parse();
				header('location: ./settings.php');
			}
	break;

	case 'changeFeedFolder':
		if($myUser==false) exit('You have to login for this action.');
		if(isset($_['feed'])){
			$feedManager->change(array('folder'=>$_['folder']),array('id'=>$_['feed']));
		}
		header('location: ./settings.php');
	break;

	case 'removeFeed':
		if($myUser==false) exit('You have to login for this action.');
		if(isset($_GET['id'])){
			$feedManager->delete(array('id'=>$_['id']));
			$eventManager->delete(array('feed'=>$_['id']));
		}
		header('location: ./settings.php');
	break;

	case 'addFolder':
		if($myUser==false) exit('You have to login for this action.');
		if(isset($_['newFolder'])){
				$folder = new Folder();
			if($folder->rowCount(array('name'=>$_['newFolder']))==0){

				$folder->setParent(-1);
				$folder->setIsopen(0);
				$folder->setName($_['newFolder']);
				$folder->save();
			}
		}
		header('location: ./settings.php');
	break;


	case 'renameFolder':
		if($myUser==false) exit('You have to login for this action.');
		if(isset($_['id'])){
			$folderManager->change(array('name'=>$_['name']),array('id'=>$_['id']));
		}
	break;

	case 'renameFeed':
		if($myUser==false) exit('You have to login for this action.');
		if(isset($_['id'])){
			$feedManager->change(array('name'=>utf8_encode(html_entity_decode($_['name']))),array('id'=>$_['id']));
		}
	break;

	case 'removeFolder':
		if($myUser==false) exit('You have to login for this action.');
		if(isset($_['id'])){
			$eventManager->customExecute('DELETE FROM '.MYSQL_PREFIX.'event WHERE '.MYSQL_PREFIX.'event.feed in (SELECT '.MYSQL_PREFIX.'feed.id FROM '.MYSQL_PREFIX.'feed WHERE '.MYSQL_PREFIX.'feed.folder ='.$_['id'].') ;');
			$feedManager->delete(array('folder'=>$_['id']));
			$folderManager->delete(array('id'=>$_['id']));
		}
		header('location: ./settings.php');
	break;

	case 'readContent':
		$event = $eventManager->load(array('id'=>$_['id']));
		if($myUser!=false) $eventManager->change(array('unread'=>'0'),array('id'=>$_['id']));
	break;

	case 'unreadContent':
		$event = $eventManager->load(array('id'=>$_['id']));
		if($myUser!=false) $eventManager->change(array('unread'=>'1'),array('id'=>$_['id']));
	break;

	case 'addFavorite':
		$eventManager->change(array('favorite'=>'1'),array('id'=>$_['id']));
	break;

	case 'removeFavorite':
		$eventManager->change(array('favorite'=>'0'),array('id'=>$_['id']));
	break;
	
	case 'login':
	
		if(isset($_['usr'])){
			$user = $userManager->existAuthToken($_['usr']);
			if($user==false){
				exit("identification error : unknown account");
			}else{
				$_SESSION['currentUser'] = serialize($user);
				header('location: ./action.php?action=addFeed&newUrl='.$_['newUrl']);
			}
		}else{
				$user = $userManager->exist($_['login'],$_['password']);
			if($user==false){
				exit("identification error : unknown account");
			}else{
				$_SESSION['currentUser'] = serialize($user);
			}
			header('location: ./index.php');	
		}
		

	
	break;

	
	case 'logout':
		$_SESSION = array();
		session_unset();
		session_destroy();
		header('location: ./index.php');
	break;
	
	default:
		exit('0');
	break;
}


?>